SystemOrganization addCategory: #CS528!

Object subclass: #GameServer
	instanceVariableNames: 'connectionSocket isRunning isRunningLock numConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528'!

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	numConnections := 0
	! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:56'!
interactOnConnection
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:11'!
interactUsing: interactionSocket
| receivedData |
	
[ receivedData := interactionSocket receiveDataTimeout: 5.
receivedData crLog.
numConnections := numConnections + 1.
interactionSocket sendData: 'ECHO: ', receivedData
] ensure: [
interactionSocket closeAndDestroy ]
! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:52'!
isRunning
	^ isRunningLock critical: [ isRunning ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:53'!
isRunning: aBoolean
	isRunningLock critical: [ isRunning := aBoolean ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:16'!
numConnections
	^numConnections ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
numConnections: aNum
	numConnections := aNum! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:58'!
serve
	[ [ self isRunning ]
	whileTrue: [ self interactOnConnection ] ]
	ensure: [ connectionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:57'!
start
	isRunningLock critical: [
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: 9999 backlogSize: 10.
	[ self serve ] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:55'!
stop
	self isRunning: false! !
